/* $Id $
	------------------------------------------------------------------
	Copyright (C) 2012 Nicklas Nordborg

	This file is part of BASE - BioArray Software Environment.
	Available at http://base.thep.lu.se/

	BASE is free software; you can redistribute it and/or
	modify it under the terms of the GNU General Public License
	as published by the Free Software Foundation; either version 3
	of the License, or (at your option) any later version.

	BASE is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with BASE. If not, see <http://www.gnu.org/licenses/>.
	------------------------------------------------------------------

	@author Nicklas
*/

var Services = function()
{
	var services = {};
	
	services.initElements = function(element, autoInit)
	{
		if (autoInit == 'control-service')
		{
			Buttons.addClickHandler(element, services.serviceCmd);
		}
		else if (autoInit == 'toggle-stacktrace')
		{
			Buttons.addClickHandler(element, services.toggleStacktrace);
		}
	}

	services.serviceCmd = function(event)
	{
		var cmd = Data.get(event.currentTarget, 'cmd');
		var extensionId = Data.get(event.currentTarget, 'extension-id');
		var url = 'index.jsp?ID='+App.getSessionId();
		url += '&cmd=' + cmd + '&extensionId='+extensionId;
		location.replace(url);
	}

	services.toggleStacktrace = function(event)
	{
		var extensionId = Data.get(event.currentTarget, 'extension-id');
		Doc.showHide('stacktrace.' + extensionId);
	}
	
	return services;
}();

Doc.addElementInitializer(Services.initElements);
