<%-- $Id: create_child_bioplate_step1.jsp 6399 2014-01-24 13:42:57Z nicklas $
	------------------------------------------------------------------
	Copyright (C) 2011 Nicklas Nordborg

	This file is part of BASE - BioArray Software Environment.
	Available at http://base.thep.lu.se/

	BASE is free software; you can redistribute it and/or
	modify it under the terms of the GNU General Public License
	as published by the Free Software Foundation; either version 3
	of the License, or (at your option) any later version.

	BASE is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with BASE. If not, see <http://www.gnu.org/licenses/>.
	------------------------------------------------------------------

	@author Nicklas
--%>
<%@ page pageEncoding="UTF-8" session="false"
	import="net.sf.basedb.core.BioPlate"
	import="net.sf.basedb.core.BioPlateEvent"
	import="net.sf.basedb.core.BioPlateEventType"
	import="net.sf.basedb.core.BioPlateType"
	import="net.sf.basedb.core.BioWell"
	import="net.sf.basedb.core.PlateGeometry"
	import="net.sf.basedb.core.MeasuredBioMaterial"
	import="net.sf.basedb.core.Hardware"
	import="net.sf.basedb.core.Protocol"
	import="net.sf.basedb.core.Tag"
	import="net.sf.basedb.core.ItemSubtype"
	import="net.sf.basedb.core.DbControl"
	import="net.sf.basedb.core.Item"
	import="net.sf.basedb.core.ItemContext"
	import="net.sf.basedb.core.ItemQuery"
	import="net.sf.basedb.core.Include"
	import="net.sf.basedb.core.SessionControl"
	import="net.sf.basedb.core.SystemItems"
	import="net.sf.basedb.core.PermissionDeniedException"
	import="net.sf.basedb.core.query.Restrictions"
	import="net.sf.basedb.core.query.Orders"
	import="net.sf.basedb.core.query.Hql"
	import="net.sf.basedb.util.Values"
	import="net.sf.basedb.util.formatter.Formatter"
	import="net.sf.basedb.clients.web.formatter.FormatterFactory"
	import="net.sf.basedb.clients.web.formatter.FormatterSettings"
	import="net.sf.basedb.clients.web.Base"
	import="net.sf.basedb.clients.web.util.HTML"
	import="java.util.List"
	import="java.util.Date"
	import="java.util.Collections"
%>
<%@ taglib prefix="base" uri="/WEB-INF/base.tld" %>
<%@ taglib prefix="tbl" uri="/WEB-INF/table.tld" %>
<%
final SessionControl sc = Base.getExistingSessionControl(pageContext, true);
final String ID = sc.getId();
final float scale = Base.getScale(sc);
final int sourcePlateId = Values.getInt(request.getParameter("sourceplate_id"));
final ItemContext cc = sc.getCurrentContext(Item.BIOPLATEEVENT, BioPlateEventType.CREATE_BIOMATERIAL);
final DbControl dc = sc.newDbControl();
try
{
	BioPlate sourcePlate = BioPlate.getById(dc, sourcePlateId);
	BioPlateType sourceType = sourcePlate.getBioPlateType();
	Item sourceBioMaterialType = sourceType.getBioMaterialType();
	PlateGeometry sourceGeometry = sourcePlate.getPlateGeometry();
	Hardware sourceFreezer = sourcePlate.getFreezer();
	
	// Load recently used items
	List<Hardware> recentHardware = (List<Hardware>)cc.getRecent(dc, Item.HARDWARE, sourceBioMaterialType.name());
	List<Protocol> recentProtocols = (List<Protocol>)cc.getRecent(dc, Item.PROTOCOL, sourceBioMaterialType.name());
	List<PlateGeometry> recentGeometry = (List<PlateGeometry>)cc.getRecent(dc, Item.PLATEGEOMETRY, sourceBioMaterialType.name());
	List<BioPlateType> recentPlateTypes = (List<BioPlateType>)cc.getRecent(dc, Item.BIOPLATETYPE, sourceBioMaterialType.name());
	List<Hardware> recentFreezers = (List<Hardware>)cc.getRecent(dc, Item.HARDWARE, "freezer");
	
	// Load subtypes
	final List<ItemSubtype> sampleSubtypes = sourceBioMaterialType == Item.SAMPLE ? 
		Base.getSubtypesQuery(Item.SAMPLE).list(dc) : null;
	final List<ItemSubtype> extractSubtypes = Base.getSubtypesQuery(Item.EXTRACT).list(dc);
	final List<ItemSubtype> bioAssaySubtypes = sourceBioMaterialType == Item.EXTRACT ? 
		Base.getSubtypesQuery(Item.PHYSICALBIOASSAY).list(dc) : null;
	// Find a common itemsubtype (if any)
	ItemSubtype commonSubtype = null;
	boolean first = true;
	for (BioWell well : sourcePlate.getBioWells().list(dc))
	{
		try
		{
			if (!well.isEmpty())
			{
				ItemSubtype subtype = well.getBioMaterial().getItemSubtype();
				if (first)
				{
					commonSubtype = subtype;
					first = false;
				}
				else
				{
					if (subtype == null || !subtype.equals(commonSubtype))
					{
						commonSubtype = null;
						break;
					}
				}
			}
		}
		catch (PermissionDeniedException ex)
		{}
	}
	final Formatter<Date> dateFormatter = FormatterFactory.getDateFormatter(sc);
	final String dateFormat = FormatterSettings.getDateFormat(sc);
	final String jsDateFormat = HTML.javaScriptEncode(dateFormat);
	final String htmlDateFormat = HTML.encodeTags(dateFormat);
	%>
	<base:page type="popup" title="Create child bioplate - step 1/2" id="step-1">
	<base:head scripts="subtypes.js,~wizards.js,~create_child_bioplate.js" />
	<base:body>
		<h1>Create child bioplate - step 1/2 <base:help helpid="bioplateevent.create-child-1" /></h1>
		
		<div id="page-data" class="datacontainer"
			data-freezer-id="<%=SystemItems.getId(Hardware.FREEZER)%>"
			data-SAMPLE="<%=Item.SAMPLE.getValue()%>"
			data-EXTRACT="<%=Item.EXTRACT.getValue()%>"
		></div>
		
		<form name="main" action="create_child_bioplate_step2.jsp" method="post">
		<input type="hidden" name="ID" value="<%=ID%>">
		<input type="hidden" name="sourceplate_id" value="<%=sourcePlateId%>">

		<div class="content bottomborder">
			<table class="fullform input100">
			<tbody class="sectionheader">
				<tr>
					<th colspan="3">Event</th>
				</tr>
			</tbody>
			<tbody>
				<tr>
					<th>Event name</th>
					<td><input class="text required" type="text" name="event_name" 
						value="Create child plate" 
						maxlength="<%=BioPlateEvent.MAX_NAME_LENGTH%>">
					</td>
					<td rowspan="4">
						<table style="width: 100%;">
						<tr>
						<td>
							<b>Description</b><br>
							<textarea class="text" rows="4" name="event_description" id="event_description"
								></textarea>
						</td>
						<td style="width: 20px;">
							<base:zoom textarea="event_description" title="Event description" />
						</td>
						</tr>
						</table>
					</td>
				</tr>
				<tr>
					<th>Event date</th>
					<td>
						<table>
						<tr>
						<td>
							<input class="text" type="text" name="event_date" id="event_date" style="width: 15em;"
								value="<%=HTML.encodeTags(dateFormatter.format(new Date()))%>" 
								maxlength="20" title="Enter date in format: <%=htmlDateFormat%>">
						</td>
						<td>
							<base:calendar textarea="event_date" title="Event date" />
						</td>
						</tr>
						</table>
					</td>
				</tr>
				<tr>
					<th>Protocol</th>
					<td>
						<base:select 
							id="protocol_id"
							clazz="selectionlist"
							required="false"
							current="<%=null%>"
							recent="<%=recentProtocols%>"
						/>
					</td>
				</tr>
				<tr>
					<th>Hardware</th>
					<td>
						<base:select 
							id="hardware_id"
							clazz="selectionlist"
							required="false"
							current="<%=null%>"
							recent="<%=recentHardware%>"
						/>
					</td>
				</tr>
			</tbody>

			<tbody class="sectionheader">
				<tr>
					<th colspan="3">Child biomaterial</th>
				</tr>
			</tbody>
			<tbody>
				<tr>
					<th>Type</th>
					<td>
						<select name="child_biomaterial_type" class="required selectionlist" id="child_biomaterial_type">
							<%
							if (sourceBioMaterialType == Item.SAMPLE)
							{
								%>
								<option value="SAMPLE">Sample → Sample
								<option value="EXTRACT" selected>Sample → Extract
								<%
							}
							else if (sourceBioMaterialType == Item.EXTRACT)
							{
								%>
								<option value="EXTRACT">Extract → Extract
								<option value="PHYSICALBIOASSAY" selected>Extract → Physical bioassay
								<%
							}
							%>
						</select>
					</td>
					<td rowspan="7">
						<table style="width: 100%;">
						<tr>
						<td>
							<b>Description</b><br>
							<textarea class="text" rows="4" name="child_description" id="child_description"></textarea>
						</td>
						<td style="width: 20px;">
							<base:zoom textarea="child_description" title="Biomaterial description" />
						</td>
						</tr>
						</table>
					</td>
				</tr>
				<tr id="sampleSubtypesDiv" style="display: none;">
					<th>Subtype</th>
					<td>
						<select name="SAMPLE_subtype_id" id="SAMPLE_subtype_id" class="selectionlist">
							<option value="0">- none -
							<%
							if (sampleSubtypes != null)
							{
								int currentSubtypeId = 0;
								if (commonSubtype != null) 
								{
									List<ItemSubtype> relatedToParent = ItemSubtype.getParentSubtypes(dc, commonSubtype, Item.SAMPLE);
									if (relatedToParent.size() > 0) currentSubtypeId = relatedToParent.get(0).getId();
								}
								for (ItemSubtype subtype : sampleSubtypes)
								{
									int id = subtype.getId();
									%>
									<option value="<%=id%>" 
										<%=id == currentSubtypeId ? "selected" : ""%>
										title="<%=HTML.encodeTags(subtype.getDescription()) %>"
										><%=HTML.encodeTags(subtype.getName())%>
									<%
								}
							}
							%>
						</select>
					</td>
				</tr>
				<tr id="extractSubtypesDiv" style="display: none;">
					<th>Subtype</th>
					<td>
						<select name="EXTRACT_subtype_id" id="EXTRACT_subtype_id" class="selectionlist">
							<option value="0">- none -
							<%
							if (extractSubtypes != null)
							{
								int currentSubtypeId = 0;
								if (commonSubtype != null) 
								{
									List<ItemSubtype> relatedToParent = ItemSubtype.getParentSubtypes(dc, commonSubtype, Item.EXTRACT);
									if (relatedToParent.size() > 0) currentSubtypeId = relatedToParent.get(0).getId();
								}
								for (ItemSubtype subtype : extractSubtypes)
								{
									int id = subtype.getId();
									%>
									<option value="<%=id%>" 
										<%=id == currentSubtypeId ? "selected" : ""%>
										title="<%=HTML.encodeTags(subtype.getDescription()) %>"
										><%=HTML.encodeTags(subtype.getName())%>
									<%
								}
							}
							%>
						</select>
					</td>
				</tr>
				<tr id="bioAssaySubtypesDiv" style="display: none;">
					<th>Subtype</th>
					<td>
						<select name="PHYSICALBIOASSAY_subtype_id" id="PHYSICALBIOASSAY_subtype_id" class="selectionlist">
							<option value="0">- none -
							<%
							if (bioAssaySubtypes != null)
							{
								int currentSubtypeId = 0;
								if (commonSubtype != null) 
								{
									List<ItemSubtype> relatedToParent = ItemSubtype.getParentSubtypes(dc, commonSubtype, Item.PHYSICALBIOASSAY);
									if (relatedToParent.size() > 0) currentSubtypeId = relatedToParent.get(0).getId();
								}
								for (ItemSubtype subtype : bioAssaySubtypes)
								{
									int id = subtype.getId();
									%>
									<option value="<%=id%>" 
										<%=id == currentSubtypeId ? "selected" : ""%>
										title="<%=HTML.encodeTags(subtype.getDescription()) %>"
										><%=HTML.encodeTags(subtype.getName())%>
									<%
								}
							}
							%>
						</select>
					</td>
				</tr>
				<tr id="tagDiv" style="display: none;">
					<th>Tag</th>
					<td>
						<base:select 
							id="tag_id"
							clazz="selectionlist"
							required="false"
							unselectedtext="<%=sourceBioMaterialType == Item.SAMPLE ? "- none -" : "- same as parent -" %>"
							current="<%=null%>"
						/>
					</td>
				</tr>
				<tr id="originalQuantityDiv">
					<th>Original quantity</th>
					<td><input class="text" type="text" name="original_quantity" id="original_quantity" style="width: 15em;"
						maxlength="10"> (µg)</td>
				</tr>
				<tr>
					<th>Used from parent</th>
					<td><input class="text" type="text" name="used_quantity" id="used_quantity" style="width: 15em;"
						maxlength="10"> (µg)</td>
				</tr>
			</tbody>
			<tbody class="sectionheader">
				<tr>
					<th colspan="3">Child plates</th>
				</tr>
			</tbody>
			<tbody>
				<tr>
					<th>No. of plates</th>
					<td><input class="text required" type="text" name="number_of_plates" id="number_of_plates"
						value="1" 
						maxlength="2" style="width: 15em;"></td>
					<td rowspan="6">
						<table style="width: 100%;">
						<tr>
						<td>
							<b>Description</b><br>
							<textarea class="text" rows="4" name="plate_description" id="plate_description"></textarea>
						</td>
						<td style="width: 20px;">
							<base:zoom textarea="plate_description" title="Plate description" />
						</td>
						</tr>
						</table>
					</td>
				</tr>
				<tr>
					<th>Name prefix</th>
					<td><input class="text required" type="text" name="plate_name_prefix" 
						value="New plate." 
						maxlength="<%=BioPlate.MAX_NAME_LENGTH%>"></td>
				</tr>
				<tr id="geometryDiv">
					<th>Geometry</th>
					<td>
						<base:select 
							id="plategeometry_id"
							clazz="selectionlist"
							required="true"
							current="<%=sourceGeometry%>"
							recent="<%=recentGeometry%>"
							newitem="true"
						/>
					</td>
				</tr>
				<tr id="sizeDiv" style="display: none;">
					<th>Size of bioassay</th>
					<td><input class="text required" type="text" name="size" id="size" style="width: 15em;"
						value="<%=sourceGeometry.getRows() %>"
						maxlength="10"></td>
				</tr>
				<tr id="plateTypeDiv">
					<th>Plate type</th>
					<td>
						<base:select 
							id="bioplatetype_id"
							clazz="selectionlist"
							required="true"
							current="<%=null%>"
							recent="<%=recentPlateTypes%>"
							newitem="true"
						/>
					</td>
				</tr>
				<tr id="freezerDiv">
					<th>Storage location</th>
					<td>
						<base:select 
							id="freezer_id"
							clazz="selectionlist"
							required="false"
							current="<%=sourceFreezer%>"
							recent="<%=recentFreezers%>"
							newitem="true"
						/>
					</td>
				</tr>
			</tbody>
			<tr class="dynamic">
				<th></th>
				<td colspan="2"></td>
			</tr>
			</table>
		</div>
		</form>

		<base:buttongroup subclass="dialogbuttons">
			<base:button id="btnNext" title="Next" />
			<base:button id="close" title="Cancel" />
		</base:buttongroup>
		
	</base:body>
	</base:page>
	<%
}
finally
{
	if (dc != null) dc.close();
}
%>