/* $Id $
	------------------------------------------------------------------
	Copyright (C) 2012 Nicklas Nordborg

	This file is part of BASE - BioArray Software Environment.
	Available at http://base.thep.lu.se/

	BASE is free software; you can redistribute it and/or
	modify it under the terms of the GNU General Public License
	as published by the Free Software Foundation; either version 3
	of the License, or (at your option) any later version.

	BASE is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with BASE. If not, see <http://www.gnu.org/licenses/>.
	------------------------------------------------------------------

	@author Nicklas
*/

var AnnotationsList = function()
{
	var list = {};
	var loaded = false;

	list.initEditLink = function(element, autoInit)
	{
		if (autoInit != 'edit-annotation') return;
		Events.addEventHandler(element, 'click', list.editAnnotation);
	}
	
	list.initListPage = function()
	{
		if (Doc.element('annotations'))
		{
			var allWithValues = Data.int('annotations-stat', 'all-with-values');
			var allOfCategory = Data.int('annotations-stat', 'all-of-category');
			Events.addEventHandler('view_all', 'click', list.setViewFilter);
			Events.addEventHandler('view_values', 'click', list.setViewFilter);
			Events.addEventHandler('view_category', 'click', list.setViewFilter);
			Doc.element('allWithValues').innerHTML = allWithValues;
			if (Doc.element('allOfCategory'))
			{
				Doc.element('allOfCategory').innerHTML = allOfCategory;
			}
			if (allWithValues == 0 && allOfCategory == 0)
			{
				Doc.element('view_all').checked = true;
			}
			list.setViewFilter();
		}
	}
	
	if (Doc.getPageId() == 'list-annotations')
	{
		Doc.addElementInitializer(list.initEditLink);
		Doc.onLoad(list.initListPage);
	}

	/**
		Load the list of annotations the first time the tab is activated.
	*/
	list.loadOnce = function()
	{
		if (loaded) return;
		var url = App.getRoot() + 'common/annotations/list_annotations.jsp?ID='+App.getSessionId();
		url += '&item_type='+Data.get('annotate-data', 'item-type');
		url += '&item_id='+Data.get('annotate-data', 'item-id');
		frames['annotations'].location.replace(url);
		loaded = true;
	}
	
	/**
		Open edit dialog for editing an annotation value in standalone mode.
	*/
	list.editAnnotation = function(event)
	{
		var target = event.currentTarget;
		var annotationTypeId = Data.get(target, 'annotation-type');
		var url =  App.getRoot() + 'common/annotations/annotate.jsp?ID='+App.getSessionId();
		url += '&item_type='+Data.get(target, 'item-type');
		url += '&item_id='+Data.get(target, 'item-id');
		url += '&annotationtype_id='+Data.get(target, 'annotation-type');
		url += '&standalone=1';
		Dialogs.openPopup(url, 'EditAnnotation', 750, 500);
	}
	
	list.setViewFilter = function()
	{
		var frm = document.forms['annotations'];
		var filter = Forms.getCheckedRadio(frm.view).value;
		Doc.element('annotations-data').className = 'data ' + filter;
	}
	
	return list;
}();



