/* $Id $
	------------------------------------------------------------------
	Copyright (C) 2012 Nicklas Nordborg

	This file is part of BASE - BioArray Software Environment.
	Available at http://base.thep.lu.se/

	BASE is free software; you can redistribute it and/or
	modify it under the terms of the GNU General Public License
	as published by the Free Software Foundation; either version 3
	of the License, or (at your option) any later version.

	BASE is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with BASE. If not, see <http://www.gnu.org/licenses/>.
	------------------------------------------------------------------

	@author Nicklas
*/

var Zoom = function()
{
	var zoomField;
	
	var zoom = {};

	zoom.initPage = function()
	{
		// Dialog buttons
		Buttons.addClickHandler('close', App.closeWindow);
		Buttons.addClickHandler('btnSave', Zoom.save);
				
		// Get the text from the parent window
		zoomField = window.opener.document.getElementById(Data.get('page-data', 'textarea'));
		var frm = document.forms['zoom'];
		frm.zoom.value = zoomField.value;
		frm.zoom.focus();
		frm.zoom.disabled = zoomField.disabled;
	}
	
	zoom.initializeToolbarElements = function(element, autoInit)
	{
		if (autoInit == 'enclose-selection')
		{
			Buttons.addClickHandler(element, zoom.textButtonOnClick);
		}
	}

	zoom.textButtonOnClick = function(event)
	{
		var prefix = Data.get(event.currentTarget, 'prefix', '');
		var suffix = Data.get(event.currentTarget, 'suffix', '');
		zoom.encloseSelection(prefix, suffix);
	}
	/*
		Enclose the selected text with prefix and suffix. Code taken
		from Trac: http://projects.edgewall.com/trac/
	*/
	zoom.encloseSelection = function(prefix, suffix)
	{
		var textarea = document.forms['zoom'].zoom;
		textarea.focus();
	    var start, end, sel, scrollPos, subst;
	    if (typeof(document["selection"]) != "undefined") 
	    {
	      sel = document.selection.createRange().text;
	    } 
	    else if (typeof(textarea["setSelectionRange"]) != "undefined") 
	    {
	      start = textarea.selectionStart;
	      end = textarea.selectionEnd;
	      scrollPos = textarea.scrollTop;
	      sel = textarea.value.substring(start, end);
	    }
	    if (sel.match(/ $/)) 
	    { 
	    	// exclude ending space char, if any
	      	sel = sel.substring(0, sel.length - 1);
	      	suffix = suffix + " ";
	    }
	    subst = prefix + sel + suffix;
	    if (typeof(document["selection"]) != "undefined") 
	    {
	      var range = document.selection.createRange().text = subst;
	      textarea.caretPos -= suffix.length;
	    } 
	    else if (typeof(textarea["setSelectionRange"]) != "undefined") 
	    {
	      textarea.value = textarea.value.substring(0, start) + subst +
	                       textarea.value.substring(end);
	      if (sel) 
	      {
	        textarea.setSelectionRange(start + subst.length, start + subst.length);
	      } 
	      else 
	      {
	        textarea.setSelectionRange(start + prefix.length, start + prefix.length);
	      }
	      textarea.scrollTop = scrollPos;
	    }
	}

	
	/**
		Save and close the popup.
	*/
	zoom.save = function()
	{
		if (!zoomField.disabled)
		{
			var value = document.forms['zoom'].zoom.value;
			zoomField.value = value;
			// Fire an 'onchange' event
			Events.sendChangeEvent(zoomField);
			zoomField.focus();
		}
		window.close();
	}
	
	return zoom;
}();

Doc.onLoad(Zoom.initPage);
Doc.addElementInitializer(Zoom.initializeToolbarElements);

